#include <gnome.h>
#include "interface.h"
#include "main.h"

/**********************************************************************************************/
BOOLEAN Calcul(unsigned int arg1, unsigned char op, unsigned int arg2, unsigned int *Result)
{
   switch (op)
   {
      case 0:
         *Result = arg1 + arg2;
         return TRUE;
      case 1:
         if (arg1==1 || arg2==1) return FALSE;
         *Result = arg1 * arg2;
         if (*Result > MAXI) return FALSE;
         return TRUE;
      case 2:
         *Result = abs(arg1 - arg2);
         if (*Result == 0) return FALSE;
         return TRUE;
      case 3:
         if (arg1==1 || arg2==1) return FALSE;
         if (arg1 % arg2 ==0)
         {
            *Result = arg1 / arg2;
            return TRUE;
         }
         if (arg2 % arg1 ==0)
         {
            *Result = arg2 / arg1;
            return TRUE;
         }
      return FALSE;
   }
   return FALSE;
}

/**********************************************************************************************/
void Moteur(int Niveau,T_DONNEE *Donnee)
{
   int i,j;
   unsigned char k;
   T_DONNEE DonneeNew[NB_CHIFFRE];
   unsigned int Resultat;
   
   for (i=0; i<NB_CHIFFRE-1;i++)
      if (!Trouve && Donnee[i].actif)
         for (j=i+1; j<NB_CHIFFRE; j++)
            if (!Trouve && Donnee[j].actif)
               for (k=0; k<4; k++)
                  if (!Trouve &&
                     Calcul(Donnee[i].valeur,k,Donnee[j].valeur, &Resultat))
                  {
                     /* operation valide => copie le resultat dans Operation */
                     Operation[Niveau].arg1     = Donnee[i].valeur;
                     Operation[Niveau].arg2     = Donnee[j].valeur;
                     Operation[Niveau].op       = k;
                     Operation[Niveau].resultat = Resultat;
                     
                     if ( abs(Bingo - Resultat) < abs(Bingo - BestRes))
                     {
                        NiveauSolution = Niveau;
                        memcpy(OperationSolution, Operation, (NB_CHIFFRE) * sizeof(T_OPERATION));
                        BestRes = Resultat;
                     }
                     if (Resultat == Bingo)
                        Trouve = TRUE;
                     if (Niveau < NB_CHIFFRE - 1)
                     {
                        memcpy(DonneeNew,Donnee, (NB_CHIFFRE) * sizeof(T_DONNEE));
                        DonneeNew[i].valeur = Resultat;
                        DonneeNew[j].actif = FALSE;
                        Moteur(Niveau+1,DonneeNew);
                     }
                  }
}

/**********************************************************************************************/
void Affiche (T_OPERATION *Solution)
{
   int i;
   char Signe;
   char str[30];
   unsigned int Terme1, Terme2;
   if (Trouve)
   {
      gtk_text_insert(GTK_TEXT(Text),NULL,NULL,NULL,"Le bon resultat est :\n",-1);
/*      g_print("Le bon resultat est :\n");*/
   }
   else
   {
      gtk_text_insert(GTK_TEXT(Text),NULL,NULL,NULL,"Le resultat le plus proche est :\n",-1);
/*      g_print("Le resultat le plus proche est :\n");*/
   }
   for (i=0; i<=NiveauSolution; i++)
   {
      switch (Solution[i].op)
      {
         case 0:
            Signe = '+';
            Terme1 = Solution[i].arg1;
            Terme2 = Solution[i].arg2;
            break;
         case 1:
            Signe = '*';
            Terme1 = Solution[i].arg1;
            Terme2 = Solution[i].arg2;
            break;
         case 2:
            Signe = '-';
            if (Solution[i].arg1 > Solution[i].arg2)
            {
               Terme1 = Solution[i].arg1;
               Terme2 = Solution[i].arg2;
            }
            else
            {
               Terme2 = Solution[i].arg1;
               Terme1 = Solution[i].arg2;
            }
            break;
         case 3:
            Signe = '/';
            if (Solution[i].arg1 > Solution[i].arg2)
            {
               Terme1 = Solution[i].arg1;
               Terme2 = Solution[i].arg2;
            }
            else
            {
               Terme2 = Solution[i].arg1;
               Terme1 = Solution[i].arg2;
            }
            break;
      }
      sprintf(&str,"%d %c %d = %d\n", Terme1, Signe, Terme2, Solution[i].resultat);
      gtk_text_insert(GTK_TEXT(Text),NULL,NULL,NULL,&str,-1);
/*      g_print("%d %c %d = %d\n", Terme1, Signe, Terme2, Solution[i].resultat);*/
   }
}

